* This is the RAMBUS ring oscillator with 4 poles
*
* Copyright: (c) 2014 Lars Hedrich, Felix Salfelder
* Author: Lars Hedrich
* License: CC-BY-SA
*>spice

.include ../PTM_180nm_bulk.mod

.subckt invb inp outp vcc vss sqratio=1
MN outp inp vss vss NMOS W='1/sqratio*100E-6' L=1E-6
MP outp inp vcc vcc PMOS W='1/sqratio*200E-6' L=1E-6
.ends invb

.subckt invf inp outp vcc vss sqratio=1
MN outp inp vss vss NMOS W='sqratio*100E-6' L=1E-6
MP outp inp vcc vcc PMOS W='sqratio*200E-6' L=1E-6
.ends invf

.subckt cell inp inm outp outm vcc vss sqratio=1.0
*  Feedback chain
XI1 inp outm vcc vss invf sqratio=sqratio
XI2 inm outp vcc vss invf sqratio=sqratio
*  Bridge:
XI3 outp outm vcc vss invb sqratio=sqratio
XI4 outm outp vcc vss invb sqratio=sqratio
.ends cell

* the ring oszillator chain
.subckt chain ina inb outa outb vcc vss sqratio=1.0
Xc1 ina inb oa1 ob1 vcc vss cell sqratio=sqratio
Xc2 oa1 ob1 outa outb vcc vss cell sqratio=sqratio
.ends chain
