* Delta-Sigma second order
*> spice

.param CInt=2E-8
.param RIn=100k
.param R1=5000

***********************************************************************
.subckt dff nin nout nclk VDD VSS
Xinv nclk iclock VDD VSS inv
XDL1 nin dl1out nclk iclock VDD VSS dlatch
XDL2 dl1out nout iclock nclk VDD VSS dlatch
.ends
***********************************************************************
.subckt dlatch nin nout nclk ICLOCK VDD nss
.param Cdl=1E-10
.param Rdl=1E3
XTrans nin transout nclk ICLOCK VDD nss trans
XInv invin nout VDD nss inv
CCap invin nss Cdl ic=0
RRdl transout invin Rdl
rdummy ICLOCK nss 100k

* ic hack
*ngspice>.model switch1 sw roff=1e9 ron=1e-9
*ngspice>s1 invin nss nic 0 switch1 ON
*ngspice>vic nic 0 PWL (0 1 100u -1 1 -1)

.ends
***********************************************************************
.subckt trans nin nout nen nien ndd nss
*>.model ts sw (vt=.5)
*>S1 nin nout nen nss ts
*spectre: model my_relay relay vt1=.49 vt2=.51
*spectre: rel1 ( nin nout nen nss ) my_relay ropen=1G rclosed=1
*ngspice>.model ts sw (vt=.5 vh=.01 roff=1e9 ron=1)
*ngspice>S1 nin nout nen nss ts
*xyce>.model ts vswitch (von=.51 voff=.49 roff=1G)
*xyce>S1 nin nout nen nss ts OFF
.ends
***********************************************************************
.subckt inv nin nout ndd ngnd
v1 noff ngnd .5
X1 noff nin nout ndd ngnd op_amp_off
.ends
***********************************************************************
.subckt op_amp_off np nn nout ndd nss
*>E1 nout noff np nn tanh gain=1e4 limit=.5
*ngspice>E1 nout noff VOL = {.5*tanh(V(np,nn)*1e4)}
*spectre: E1 (nout noff) bsource v=.5*tanh(1e4*V(np,nn))
*xyce>E1 nout noff value = .5*tanh(V(np,nn)*1e4)
V1 noff nss .5
.ends
***********************************************************************
.subckt sigma_delta nin ncc ngnd nclk nout

* Divider
Rdiv1 ncc nhalf R1
Rdiv2 nhalf ngnd R1

Rin nin neg_op1 RIn

Rin2 nint1 neg_op2 RIn

* integrator 1
XInt1 nhalf neg_op1 nint1 ndd ngnd op_amp_off
Cint1 nint1 neg_op1 CInt ic=0
* Zop nhalf neg_op1 nint1 ngnd Z_OP_BEHAVE PARAMS=(a=1e4 v_max=0.5 i_max=1e-3 offset=0.0)

* integrator 2
XInt2 nhalf neg_op2 nint2 ndd ngnd op_amp_off
Cint2 nint2 neg_op2 CInt ic=0

* probe hack
Ef1 ncfill1 0 nint1 neg_op1 1
Ef2 ncfill2 0 nint2 neg_op2 1

* ic hack
*ngspice>.model switch1 sw roff=1e9
*ngspice>s1 nint1 neg_op1 nic 0 switch1 ON
*ngspice>s2 nint2 neg_op2 nic 0 switch1 ON
*ngspice>vic nic 0 PWL (0 1 1f -1 2f -1)

* comparator
Xcmp nhalf nint2 ncmp ndd ngnd op_amp_off
Rout ncmp ngnd 1k

* D-Flipflop
Xff ncmp nq nclk ncc ngnd dff

* Feedback
Xinv nq nout ncc ngnd inv

Rfb1 nq neg_op1 RIn
Rfb2 nout neg_op2 RIn


.ends sigma_delta
